import React from "react";
import { useFuzzyInput } from "../../hooks/useFuzzyInput";
var Input = function (_a) {
    var value = _a.value, onChange = _a.onChange, onSearchClick = _a.onSearchClick, _b = _a.loading, loading = _b === void 0 ? false : _b, _c = _a.placeHolder, placeHolder = _c === void 0 ? "Search..." : _c;
    // needed to pass input value to onClick at span
    var inputRef = React.useRef(null);
    var inputCtx = useFuzzyInput();
    var checkIncludes = function (activeKeys, fuseKeys) {
        return activeKeys.every(function (key) { return fuseKeys.includes(key); });
    };
    return (React.createElement(React.Fragment, null,
        React.createElement("form", { className: "zim-fuzzy--input-form", onSubmit: onSearchClick
                ? function (evt) {
                    evt.preventDefault();
                    onSearchClick(inputRef.current ? inputRef.current.value : "");
                    if (inputCtx.onSearch)
                        inputCtx.onSearch(value ? value : "");
                }
                : function (evt) { return evt.preventDefault(); } },
            React.createElement("div", { className: "input-group mb-3 zim-fuzzy--input-group" },
                React.createElement("div", { className: "input-group-prepend" },
                    React.createElement("button", { className: "input-group-text", type: "submit" }, !loading ? (React.createElement("span", { className: "fa fa-search" })) : (React.createElement("div", { className: "spinner-border spinner-border-sm", role: "status" },
                        React.createElement("span", { className: "sr-only" }, "Loading..."))))),
                React.createElement("input", { ref: inputRef, className: "form-control", value: value ? value : "", onChange: function (evt) { return onChange(evt.currentTarget.value); }, type: "text", disabled: loading, placeholder: !loading ? placeHolder : "..." }),
                React.createElement("div", { className: "input-group-append" },
                    React.createElement("button", { type: "button", className: "input-group-text", onClick: function () {
                            onChange(null);
                            if (onSearchClick) {
                                onSearchClick("");
                            }
                        } },
                        React.createElement("span", null,
                            React.createElement("i", { className: "fa fa-times XIcon", style: { cursor: "pointer" }, title: "Delete" })))))),
        inputCtx.fuseKeyMap && inputCtx.fuseStateOptions.keys ? React.createElement(React.Fragment, null,
            React.createElement("ul", { className: "nav" },
                React.createElement("li", { className: "nav-item" },
                    React.createElement("a", { className: "nav-link " + (checkIncludes(Object.keys(inputCtx.fuseKeyMap), inputCtx.fuseStateOptions.keys) ? "active" : ""), href: "#s", onClick: function (evt) {
                            evt.preventDefault();
                            inputCtx.toggleFuseKey(Object.keys(inputCtx.fuseKeyMap));
                        } }, "Alle")),
                Object.keys(inputCtx.fuseKeyMap).map(function (fuseKey) { return React.createElement("li", { key: fuseKey, className: "nav-item" },
                    React.createElement("a", { href: "#a", onClick: function (evt) {
                            evt.preventDefault();
                            inputCtx.toggleFuseKey([fuseKey]);
                        }, className: "nav-link " + (checkIncludes(inputCtx.fuseStateOptions.keys, [fuseKey]) ? "active" : "") }, 
                    //@ts-ignore
                    inputCtx.fuseKeyMap[fuseKey].label)); })),
            React.createElement("br", null)) : null));
};
export default Input;
